Bug 1429442 - glibc: libresolv does not enforce timeouts on TCP connections
Summary: glibc: libresolv does not enforce timeouts on TCP connections
Keywords:
Status: CLOSED UPSTREAM
Alias: None
Product: Red Hat Enterprise Linux 8
Classification: Red Hat
Component: glibc
Version: 8.2
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: 8.2
Assignee: glibc team
QA Contact: qe-baseos-tools-bugs
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-03-06 11:59 UTC by Florian Weimer
Modified: 2020-02-24 14:46 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-02-24 14:46:50 UTC
Type: Bug
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Sourceware 19643 P2 ASSIGNED libresolv: Lack of TCP timeout 2020-07-13 13:13:18 UTC
Sourceware 19696 P2 RESOLVED libresolv does not enforce timeouts on TCP connections 2020-07-13 13:13:18 UTC

Description Florian Weimer 2017-03-06 11:59:02 UTC
Description of problem (from upstream):

The TCP sockets opened by libresolv do not specify timeouts (for connection, sending and receiving).  As a result, connection timeouts take much longer than configured, and applications performing a TCP lookup can hang indefinitely if the TCP connection is severed at the wrong time (without FIN or RST segments being received).

This affects the NSS functions for the hosts database, too (getaddrinfo etc.).

At least one commercial DNS fuzzer can send TC=1 replies, but then fail to respond on the TCP port (it accepts the connection, but does not respond).  As a result, this bug can introduce spurious hangs into the fuzzing process, making the interpretation of the results more difficult.

Comment 5 Carlos O'Donell 2020-02-24 14:46:50 UTC
We are tracking this bug upstream:
"Bug 19643 - libresolv: Lack of TCP timeout"
https://sourceware.org/bugzilla/show_bug.cgi?id=19643

I am going to close this as CLOSED/UPSTREAM and we will continue the design and discussion upstream.

When this is ready it can be backported as required into the appropriate branches.


Note You need to log in before you can comment on or make changes to this bug.